package com.gic.haoban.manage.web.handle;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.commons.util.DataApiUtils;
import com.gic.enterprise.api.dto.security.DownloadReportDTO;
import com.gic.haoban.manage.web.vo.eventtracking.WechatEventTrackingClerkVO;
import com.gic.web.common.download.DownloadHandlerAbstract;
import com.gic.web.common.download.context.Context;
import org.apache.commons.collections.CollectionUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.stereotype.Component;

import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * 数据-登录数据-好办使用详情
 */
@Component
public class WechatEventTrackingClerkDetailHandle extends DownloadHandlerAbstract<WechatEventTrackingClerkVO> {

    private static final Logger LOGGER = LogManager.getLogger(WechatEventTrackingClerkDetailHandle.class);

    @Override
    public List<WechatEventTrackingClerkVO> getData(Context context, String searchDataParams, Integer currentPage) {
        boolean isFirst = currentPage != null && currentPage == 1;
        if (isFirst) {
            LOGGER.info("数据-登录数据-好办使用导购详情导出日志");
        }
        JSONObject jsonObject = JSON.parseObject(searchDataParams);
        jsonObject.put("pageNum", currentPage);
        jsonObject.put("pageSize", getPageSize());
        Map<String, Object> res = DataApiUtils.http(jsonObject.toJSONString(), jsonObject.getString("apolloKey"));
        List<JSONObject> list = DataApiUtils.getPageList(res);
        if (CollectionUtils.isNotEmpty(list)) {
            List<WechatEventTrackingClerkVO> result = JSONObject.parseArray(JSON.toJSONString(list), WechatEventTrackingClerkVO.class);
            return result;
        }
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<String> getColumnNames() {
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<String> getColumnNames(Context context){
        DownloadReportDTO downloadReportDTO = context.getDownloadReportDTO();
        String searchDataParams = downloadReportDTO.getSearchDataParams();
        JSONObject jsonObject = JSONObject.parseObject(searchDataParams);
        List<String> list = (List<String>) jsonObject.get("indexList");
        return list;
    }

    @Override
    public LinkedHashMap<String, List<String>> doubleColumnNames() {
        return null;
    }

    @Override
    public List<String> getColumns() {
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<String> getColumns(Context context) {
        DownloadReportDTO downloadReportDTO = context.getDownloadReportDTO();
        String searchDataParams = downloadReportDTO.getSearchDataParams();
        JSONObject jsonObject = JSONObject.parseObject(searchDataParams);
        List<String> list = (List<String>) jsonObject.get("fieldList");
        return list;
    }
}
